﻿using System.Linq;
using System.Threading.Tasks;
using Buddy.Coroutines;
using ff14bot;
using ff14bot.AClasses;
using ff14bot.Behavior;
using ff14bot.Managers;
using ff14bot.RemoteWindows;
using TreeSharp;

namespace HouseBuyer
{

    public class HouseBuyer : BotBase
    {
        // English name = "Placard"
        // Chinese name = "门牌"
        private const string PlacardName = "Placard";

        internal async Task<bool> BuyTheFuckingHouse()
        {
            // Select whether to buy for personal or FC
            if (SelectString.IsOpen)
            {
                // 0 = Buy Personal
                // 1 = Buy FC        
                SelectString.ClickSlot(0);
                return false;
            }

            // Click the yes button if the window is up
            if (SelectYesno.IsOpen)
            {
                SelectYesno.ClickYes();
                return false;
            }

            // Find the placard and the window
            var placard = GameObjectManager.GameObjects.FirstOrDefault(r => r.Name == PlacardName && r.Distance2D(Core.Me) <= 3);

            if (placard == null)
                return false;

            var window = RaptureAtkUnitManager.GetRawControls.FirstOrDefault(r => r.Name == "HousingSignBoard");

            // Select the Purchase House button if the placard is up
            if (window != null)
            {
                window.SendAction(1, 1, 1);
                await Coroutine.Wait(500, () => SelectString.IsOpen || SelectYesno.IsOpen);
                return false;
            }

            // Interact with the Placard if it's selected but the window isn't up
            if (Core.Me.CurrentTarget == placard && window == null)
            {
                Core.Me.CurrentTarget.Interact();
            }

            // Select the placard if it's not selected
            if (Core.Me.CurrentTarget != placard)
            {
                placard.Target();
            }

            return false;
        }

        public override void Start()
        {
            _root = new ActionRunCoroutine(r => BuyTheFuckingHouse());
        }

        public override string Name => "House Buyer";
        public override PulseFlags PulseFlags => PulseFlags.All;
        public override Composite Root => _root;
        private Composite _root;
        public override bool RequiresProfile => false;
    }

}